
dofile("src/basic.lua")
dofile("src/comprobar.lua")
dofile("src/menu.lua")
dofile("src/editor.lua")

dofile("intro/script.lua")



tiempo=tonumber(ini.read("config.ini","tiempo",5))
marcar=tonumber(ini.read("config.ini","marcar",0))
repeticiones=tonumber(ini.read("config.ini","repeticiones",0))


--0 Casilla vaca

--Blancas & Negras
--1 Pen
--2 Torre
--3 Caballo
--4 Alfil
--5 Reina
--6 Rey

lcd=font.load("lcd.pgf")

turno=2
verde=color.new(0,255,0)
blanco_t=color.new(240,240,240,120)
naranja=color.new(232,97,0)
blanco=color.new(255,255,255)
negro=color.new(0,0,0)
gris=color.new(140,140,140)


pieza={}
for i=1,12 do
	pieza[i]=image.load("img/"..i..".png")
end

tablero=image.load("img/tablero.png")


function prede()
chess={
{2,3,4,5,6,4,3,2},
{1,1,1,1,1,1,1,1},
{0,0,0,0,0,0,0,0},
{0,0,0,0,0,0,0,0},
{0,0,0,0,0,0,0,0},
{0,0,0,0,0,0,0,0},
{7,7,7,7,7,7,7,7},
{8,9,10,12,11,10,9,8},
}
end

trans=100
dt=1


function convertsegtomin(seg)

minutos=math.floor(seg/60)
segundos=seg-minutos*60
return minutos,segundos

end


function cambio()
	nuevo=chess[py][px]
	
	if repeticiones==1 then

		txt={}
		txt[1]="\nchess["..oldy.."]["..oldx.."]=0"
		txt[2]="chess["..py.."]["..px.."]="..sel
		txt[3]="actualizar()"

		a=io.open("rec/"..last..".lua","a+")
		a:write(table.concat(txt,"\n"))
		a:close()
	end

	
	if nuevo>6 then
		if nuevo==11 then reinaB=false end
		if nuevo==12 then
			os.message("Las NEGRAS ganan")
			menu()
		end
		table.insert(perdidasB,nuevo)
	else
		if nuevo>0 then
			if nuevo==5 then reinaA=false end
			if nuevo==6 then
				os.message("Las BLANCAS ganan")
				menu()
			end
			table.insert(perdidasA,nuevo)
		end
	end

	chess[oldy][oldx]=0
	chess[py][px]=sel
	sel=0
	posibles={
		{0,0,0,0,0,0,0,0},
		{0,0,0,0,0,0,0,0},
		{0,0,0,0,0,0,0,0},
		{0,0,0,0,0,0,0,0},
		{0,0,0,0,0,0,0,0},
		{0,0,0,0,0,0,0,0},
		{0,0,0,0,0,0,0,0},
		{0,0,0,0,0,0,0,0},
	}
	oldx=0
	oldy=0
	if turno==1 then 
		segundosA:start()
		segundosB:stop()
		turno=2
	else
		segundosB:start()
		segundosA:stop()
		turno=1
	end
end


function juego()

py=4
px=4

sel=0
oldx=0
oldy=0

posibles={
{0,0,0,0,0,0,0,0},
{0,0,0,0,0,0,0,0},
{0,0,0,0,0,0,0,0},
{0,0,0,0,0,0,0,0},
{0,0,0,0,0,0,0,0},
{0,0,0,0,0,0,0,0},
{0,0,0,0,0,0,0,0},
{0,0,0,0,0,0,0,0},
}

reinaA=true
reinaB=true

segundosA=timer.new()
segundosB=timer.new()
segundosA:start()
perdidasA={}
perdidasB={}


if repeticiones==1 then

	last=1
	while files.exists("rec/"..last..".lua") do
		last=last+1
	end

	txt={}
	txt[1]="chess={"
	for y=1,8 do
		txt[#txt+1]="{"
		for x=1,8 do
			txt[#txt]=txt[#txt]..chess[y][x]..","
		end
		txt[#txt]=txt[#txt]:sub(1,txt[#txt]:len()-1).."},"
	end

	txt[#txt+1]="}"

	a=io.open("rec/"..last..".lua","w+")
	a:write(table.concat(txt,"\n"))
	a:close()
	txt=nil
end

while true do
controls.read()
screen.clear(blanco)

tablero:blit(118,12)
blanco_t=color.new(240,240,240,trans)
verde=color.new(0,255,0,trans)

if dt==1 then trans=trans+2 else trans=trans-2 end
if trans>255 then dt=2 end
if trans<50 then dt=1 end

if controls.press("down") then py=py+1 elseif controls.press("up") then py=py-1 end
if controls.press("right") then px=px+1 elseif controls.press("left") then px=px-1 end
if px>8 then px=1 elseif px<1 then px=8 end
if py>8 then py=1 elseif py<1 then py=8 end

--Pieza seleccionada
draw.fillrect(110+px*26,6+py*26,26,26,blanco_t)

if oldx!=0 then
	if chess[oldy][oldx]!=0 then
		draw.fillrect(110+oldx*26,6+oldy*26,26,26,naranja)
	end
end


for y=1,8 do
	for x=1,8 do
		if marcar==1 then
			if sel!=0 then
				if posibles[y][x]==1 then
					draw.fillrect(110+x*26,6+y*26,26,26,verde)
				end
			end
		end
		if chess[y][x]!=0 then
			--X=136(118+18)-26,Y=32(12+20)-26
			pieza[chess[y][x]]:blit(110+x*26,6+y*26)
		end
	end
end

draw.rect(110+px*26,6+py*26,26,26,negro)

for i=1,#perdidasB do
	if i<9 then
		pieza[perdidasB[i]]:blit(360,26*i)
	else
		pieza[perdidasB[i]]:blit(390,26*i-26*8)
	end
end
for i=1,#perdidasA do
	if i<9 then
		pieza[perdidasA[i]]:blit(420,26*i)
	else
		pieza[perdidasA[i]]:blit(450,26*i-26*8)
	end
end

if controls.press("circle") then
	if sel!=0 then
		posibles={
			{0,0,0,0,0,0,0,0},
			{0,0,0,0,0,0,0,0},
			{0,0,0,0,0,0,0,0},
			{0,0,0,0,0,0,0,0},
			{0,0,0,0,0,0,0,0},
			{0,0,0,0,0,0,0,0},
			{0,0,0,0,0,0,0,0},
			{0,0,0,0,0,0,0,0},
		}
	end
	sel=0
	oldx=0
	oldy=0
end

if turno==1 then
	if segundosB:time()>tiempo*60000 then
		os.message("Las Negras pierden")
		menu()
	end
else
	if segundosA:time()>tiempo*60000 then
		os.message("Las Blancas pierden")
		menu()
	end
end

a,b=convertsegtomin(math.floor(tiempo*60-segundosA:time()/1000))

screen.print(lcd,10,60,"BLANCAS",negro)
screen.print(lcd,20,90,a..":"..b,negro)

a,b=convertsegtomin(math.floor(tiempo*60-segundosB:time()/1000))
screen.print(lcd,10,150,"NEGRAS",negro)
screen.print(lcd,20,180,a..":"..b,negro)


if controls.press("cross") then
	--Seleccionamos 1
	if sel==0 then
		if turno==1 then
			if chess[py][px]<7 and chess[py][px]>0 then
				sel=chess[py][px]
				oldx=px
				oldy=py
				if marcar==1 then comprobar() end
			end
		else
			if chess[py][px]>6 then
				sel=chess[py][px]
				oldx=px
				oldy=py
				if marcar==1 then comprobar() end
			end
		end
	else
		if px!=oldx or py!=oldy then
			--Si ya haba una seleccionada
			--Variables
			dy=oldy-py
			dx=oldx-px
			--Negras
			if sel==1 then 
				peonA()
			elseif sel==2 then
				torreA()
			elseif sel==3 then
				caballoA()
			elseif sel==4 then
				alfilA()
			elseif sel==5 then
				torreA()
				alfilA()
			elseif sel==6 then
				reyA()
			end
			
			--Blancas
			if sel==7 then
				peonB()
			elseif sel==8 then
				torreB()
			elseif sel==9 then
				caballoB()
			elseif sel==10 then
				alfilB()
			elseif sel==11 then
				torreB()
				alfilB()
			elseif sel==12 then
				reyB()
			end
		end
	end
end

if controls.press("start") then
	if os.message("Estas seguro de que seas volver al men inicial?",1)==1 then
		menu()
	end
end

screen.flip()
end

end


menu()		